function formatNumber(n) {
  const str = n.toString()
  return str[1] ? str : `0${str}`
}
// 防抖
export function debounce(fn, wait) {
  var timeout = null;
  return function() {
      if (timeout !== null)
          clearTimeout(timeout);
      timeout = setTimeout(fn, wait);
  }
}

// 节流
export function throttle(func, delay) {
  var prev = Date.now();
  return function() {
      var context = this;
      var args = arguments;
      var now = Date.now();
      if (now - prev >= delay) {
          func.apply(context, args);
          prev = Date.now();
      }
  }
}

//格式时间
export function formatTime(date) {
  const year = date.getFullYear()
  const month = date.getMonth() + 1
  const day = date.getDate()

  const hour = date.getHours()
  const minute = date.getMinutes()
  const second = date.getSeconds()

  const t1 = [year, month, day].map(formatNumber).join('/')
  const t2 = [hour, minute, second].map(formatNumber).join(':')

  return `${t1} ${t2}`
}

//对象转querystring
export function serialize(obj) {
  var str = [];
  if (typeof obj == "string") {
    obj = JSON.parse(obj);
  }
  for (var p in obj) {
    if (obj.hasOwnProperty(p)) {
      str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
    }
  }
  return str.join("&");
}


//获取url参数
export function getQueryVariable(query,variable) {
  // var query = window.location.search.substring(1);
  var vars = query.split("&");
  for (var i = 0; i < vars.length; i++) {
    var pair = vars[i].split("=");
    if (pair[0] == variable) { return pair[1]; }
  }
  return (false);
}
// 删除
export function delUrlParam(url, key) {
  let baseUrl = url.split('?')[0] + '?';
  let query = url.split('?')[1];
  if (query.indexOf(key) > -1) {
      let obj = {};
      let arr = query.split('&');
      for (let i = 0; i < arr.length; i++) {
          arr[i] = arr[i].split('=');
          obj[arr[i][0]] = arr[i][1];
      }
      delete obj[key];
      let url =
          baseUrl +
          JSON.stringify(obj)
              .replace(/[\"\{\}]/g, '')
              .replace(/\:/g, '=')
              .replace(/\,/g, '&');
      return url;
  } else {
      return url;
  }
}

//补全图片路径
export function DFSImg(path, w, h,type=0) { //
  if (path == null || path == '') {
    return 'https://mayi-newshop.oss-cn-shanghai.aliyuncs.com/product/8ezKQbm2x3.png';
  }
  let baseImg = process.env.IMG_DOMAIN ;
  if (!Array.isArray(baseImg) && (baseImg.indexOf('aliyun') >= 0 || baseImg.indexOf('cdn') >= 0 )) {
    var style = '';
    if (w) style += ',w_' + w;
    if (h) style += ',h_' + h;
    if (style.length > 0) {
      if(path.indexOf('?x-oss-process') == -1){
        if(type == 1){
          path += '?x-oss-process=image/resize,limit_0' + style
        }else{
          path += '?x-oss-process=image/resize,m_pad,limit_0' + style
        }
        
      }
    }
    if (path.indexOf('http') == 0) {
      return path;
    }
    return baseImg + path;
  } else {
    if (path.indexOf('http') == 0) {
      return path;
    }
    if (path.indexOf('/') != 0) {
      path = '/' + path;
    }
    if (w && h) {
      path += '.' + w + 'x' + h + '.jpg';
    }

    return baseImg[Math.floor(Math.random() * 100) % baseImg.length] + path;
  }
}
// 获取Navbar高度
export function getNavbarInfo(fn) {
  let menuInfo = wx.getMenuButtonBoundingClientRect(); //右上角胶囊信息
  wx.getSystemInfo({
    success: (res) => {
      fn({
        navTop: res.statusBarHeight, //状态栏高度
        navHeight: res.statusBarHeight + menuInfo.height + (menuInfo.top - res.statusBarHeight) * 2 //导航栏高度
      })
    }
  })
}


export function setTimes(value){
  let result = parseInt(value)
　　let h = Math.floor(result / 3600) < 10 ? '0' + Math.floor(result / 3600) : Math.floor(result / 3600)
　　let m = Math.floor((result / 60 % 60)) < 10 ? '0' + Math.floor((result / 60 % 60)) : Math.floor((result / 60 % 60))
　　let s = Math.floor((result % 60)) < 10 ? '0' + Math.floor((result % 60)) : Math.floor((result % 60))
　　result = `${h}:${m}:${s}`
　　return result
}